-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicThreat-TBC"] = q.modules["QoL_ClassicThreat-TBC"] or {};
local c = q.modules["QoL_ClassicThreat-TBC"];

local frames = {};

function c:GetPartyFrame(partyId)
	local unitId = "party" .. partyId;
	if not frames[unitId] then
		frames[unitId] = CreateFrame("Frame", "PartyThreatFrame_" .. partyId, _G["PartyMemberFrame" .. partyId], BackdropTemplateMixin and "BackdropTemplate");
		frames[unitId]:SetPoint("TOPLEFT", _G["PartyMemberFrame" .. partyId], "TOPRIGHT", -14, -10);
		frames[unitId]:SetSize(42, 21);

		frames[unitId].background = frames[unitId]:CreateTexture(nil, "BACKGROUND");
		frames[unitId].background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		frames[unitId].background:SetPoint("TOPLEFT", 2 , -2);
		frames[unitId].background:SetPoint("BOTTOMRIGHT", -2 , 2);

		frames[unitId].text = frames[unitId]:CreateFontString("PartyMemberFrame" .. partyId .. "FontString", "ARTWORK", "GameFontNormalSmall");
		frames[unitId].text:SetTextColor(1, 1, 1, 1);
		frames[unitId].text:SetPoint("TOPLEFT", frames[unitId], "TOPLEFT", 2, 0);
		frames[unitId].text:SetPoint("BOTTOMRIGHT", frames[unitId], "BOTTOMRIGHT", 0, 0);

		frames[unitId]:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10,
			insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	end
	return frames[unitId];
end

-- TODO:
function c:GetRaidFrame(partyId)
	local unitId = "raid" .. partyId;
	if not frames[unitId] then
		frames[unitId] = CreateFrame("Frame", "RaidThreatFrame_" .. partyId, _G["PartyMemberFrame" .. partyId], BackdropTemplateMixin and "BackdropTemplate");
		frames[unitId]:SetPoint("TOPLEFT", _G["PartyMemberFrame" .. partyId], "TOPRIGHT", -14, -10);
		frames[unitId]:SetSize(42, 21);

		frames[unitId].background = frames[unitId]:CreateTexture(nil, "BACKGROUND");
		frames[unitId].background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		frames[unitId].background:SetPoint("TOPLEFT", 2 , -2);
		frames[unitId].background:SetPoint("BOTTOMRIGHT", -2 , 2);

		frames[unitId].text = frames[unitId]:CreateFontString("PartyMemberFrame" .. partyId .. "FontString", "ARTWORK", "GameFontNormalSmall");
		frames[unitId].text:SetTextColor(1, 1, 1, 1);
		frames[unitId].text:SetPoint("TOPLEFT", frames[unitId], "TOPLEFT", 2, 0);
		frames[unitId].text:SetPoint("BOTTOMRIGHT", frames[unitId], "BOTTOMRIGHT", 0, 0);

		frames[unitId]:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10,
			insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	end
	return frames[unitId];
end

function c:GetTargetThreatFrame()
	if not frames["target"] then
		frames["target"] = CreateFrame("Frame", "TargetThreatFrame", TargetFrame, BackdropTemplateMixin and "BackdropTemplate");
		frames["target"]:SetPoint("TOPLEFT", TargetFrame ,"TOPLEFT", 2, -2);
		frames["target"]:SetFrameStrata("BACKGROUND");
		frames["target"]:SetSize(155, 40);

		frames["target"].text = frames["target"]:CreateFontString("TargetThreatFrameFontString", "ARTWORK", "GameFontNormal");
		frames["target"].text:SetTextColor(1, 1, 1, 1);
		frames["target"].text:SetPoint("TOPLEFT", frames["target"] ,"TOPLEFT", 0, -7);
		frames["target"].text:SetPoint("TOPRIGHT", frames["target"] ,"TOPRIGHT", 0, -7);

		frames["target"].background = frames["target"]:CreateTexture(nil, "BACKGROUND");
		frames["target"].background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		frames["target"].background:SetPoint("TOP", 0 , -3);
		frames["target"].background:SetSize(152, 16);

		frames["target"].glow = frames["target"]:CreateTexture(nil, "BACKGROUND");
		frames["target"].glow:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
		frames["target"].glow:SetTexCoord(0, 0.955, 0, 0.755);
		frames["target"].glow:SetPoint("TOPLEFT", -24, 0);
		frames["target"].glow:SetSize(242, 93);
		frames["target"].glow:Hide();

		frames["target"]:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 8, right = 8, top = 8, bottom = 8 }});
	end
	return frames["target"];
end

function c:GetPlayerThreatFrame()
	if not frames["player"] then
		frames["player"] = CreateFrame("Frame", "PlayerThreatFrame", PlayerFrame, BackdropTemplateMixin and "BackdropTemplate");
		frames["player"]:SetPoint("TOPLEFT", PlayerFrame ,"TOPRIGHT", -157, -2);
		frames["player"]:SetFrameStrata("BACKGROUND");
		frames["player"]:SetSize(155, 40);

		frames["player"].text = frames["player"]:CreateFontString("PlayerThreatFrameFontString", "ARTWORK", "GameFontNormal");
		frames["player"].text:SetTextColor(1, 1, 1, 1);
		frames["player"].text:SetPoint("TOPLEFT", frames["player"] ,"TOPLEFT", 0, -7);
		frames["player"].text:SetPoint("TOPRIGHT", frames["player"] ,"TOPRIGHT", 0, -7);

		frames["player"].background = frames["player"]:CreateTexture(nil, "BACKGROUND");
		frames["player"].background:SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		frames["player"].background:SetPoint("TOP", 0 , -3);
		frames["player"].background:SetSize(152, 16);

		frames["player"]:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = { left = 8, right = 8, top = 8, bottom = 8 }});
	end
	return frames["player"];
end

function c:HideFrames()
	for unitId, frame in pairs(frames) do
		frame:Hide();
	end
end